#include <stdio.h>

int main(int argc, char *argv[]){
	FILE *fp1, *fp2;
	unsigned int i;
	
	if(argc < 3){
		fprintf(stderr, "usage: diff [file1] file2]\n");
		return 1;
	}
	
	if(!(fp1 = fopen(argv[1], "rb"))){
		fprintf(stderr, "file %s not found\n", argv[1]);
		return 1;
	}
	
	if(!(fp2 = fopen(argv[2], "rb"))){
		fprintf(stderr, "file %s not found\n", argv[2]);
		fclose(fp1);
		return 1;
	}
	
	for(i = 0; ; i++){
		char d1, d2;
		size_t s1, s2;
		
		s1 = fread(&d1, sizeof(char), 1, fp1);
		s2 = fread(&d2, sizeof(char), 1, fp2);
		
		if((s1 == 1) && (s2 == 1)){
			if(d1 != d2)
				printf("%d-%d: %d <---> %d\n", i >> 4, i & 15, d1, d2);
		}
		else if(s1 == s2)
			break;
		else{
			printf("differs in file length\n");
			break;
		}
	}
	
	fclose(fp2);
	fclose(fp1);
	
	return 0;
}
